#include <creaImageIOSystem.h>
#include <creaWx.h>
#include <creaImageIOWxGimmickDialog.h>

#include <creaVtkBasicSlicer.h>

class myApp : public wxApp
{
public:
  bool OnInit( );
  int  OnExit() { return true; }
};

IMPLEMENT_APP(myApp);

CREA_WXMAIN_WITH_CONSOLE

bool myApp::OnInit( )
{	 
  wxApp::OnInit();
#ifdef __WXGTK__
  //See http://www.wxwindows.org/faqgtk.htm#locale
  setlocale(LC_NUMERIC, "C");
#endif
   wxInitAllImageHandlers();

   int image_type = GIMMICK_3D_IMAGE_SELECTION;
   int threads = 1;

   creaImageIO::WxGimmickDialog w(0,
				  -1,
				  _T("Select image(s)        - Gimmick! (c) CREATIS-LRMN 2008"),
				  wxDefaultPosition,
				  wxSize(1200,800),
				  image_type,
				  threads);
   w.ShowModal();
   
   if (w.GetReturnCode() == wxID_OK)
     {
       std::cout << "$$$$ main : user clicked 'OK' $$$$"<<std::endl;
       std::cout << "$$$$ selected files : "<<std::endl;
       std::vector<std::string> s;
       w.GetSelectedFiles(s);
       std::vector<std::string>::iterator i;
       for (i=s.begin();i!=s.end();++i) 
	 {
	   std::cout << *i << std::endl;
	 }
       std::cout << "$$$$ "<<std::endl;

       std::vector<vtkImageData*> images;
       w.GetSelectedImages(images);
       crea::VtkBasicSlicer(images.front());
       images.front()->Delete();

     }
   else if (w.GetReturnCode() == wxID_CANCEL)
     {
       std::cout << "$$$$ main : user clicked 'CANCEL' $$$$"<<std::endl;
     }
   else 
     {
        std::cout << "$$$$ main : dialog ended without return code ! $$$$"
		  <<std::endl;
      
     }

   //   std::cout << "$$$$ main : deleting dialog"<<std::endl;
   //   delete w;
   std::cout << "$$$$$$$$$$$$$$$$$$$$ main ended "<<std::endl;
   return false;
}


