#include <creaImageIODicomNodeComparators.h>
#include <creaImageIODicomNode.h>

namespace creaImageIO
{

  //===================================================================
  bool DicomNodeIntFieldComparator::compare(DicomNode* const & x, 
					    DicomNode* const & y) 
  { 
    int ix = atoi(x->GetFieldValue(mKey).c_str());
    int iy = atoi(y->GetFieldValue(mKey).c_str());   
    //      std::cout << ix << " < " << iy << " ? "<<std::endl;
    return (ix<iy);
  }
  //===================================================================
  
  //===================================================================
  bool DicomNodeFloatFieldComparator::compare(DicomNode* const & x, 
					      DicomNode* const & y) 
  { 
    if ( x->GetFieldValue(mKey) == y->GetFieldValue(mKey) )
      return false;
    float ix = atof(x->GetFieldValue(mKey).c_str());
    float iy = atof(y->GetFieldValue(mKey).c_str());   
    return (ix < iy);
  }
  //===================================================================
  
  
  //===================================================================
  bool DicomNodeStringFieldComparator::compare(DicomNode* const & x,
					       DicomNode* const & y) 
  { 
    return (  x->GetFieldValue(mKey) < y->GetFieldValue(mKey) );
  }
  //===================================================================

  //===================================================================
  bool LexicographicalDicomNodeComparator::operator() (DicomNode* const & x, 
						       DicomNode * const & y)
  {
    std::vector<DicomNodeComparator*>::iterator i;
    for (i =mDicomNodeComparator.begin();
	 i!=mDicomNodeComparator.end();
	 ++i)
      {
	if ( (*i)->operator()(x,y) ) 
	  {
	    return true;
	  }
	if ( (*i)->operator()(y,x) ) 
	  {
	    return false;
	  }
      }
    return false;
  }
  //===================================================================

}
