#ifndef __creaImageIOWxGimmickFieldsView_h_INCLUDED__
#define __creaImageIOWxGimmickFieldsView_h_INCLUDED__

#include <creaImageIODicomDatabase.h>

#include <creaWx.h>

#include "wx/image.h"
#include "wx/imaglist.h"
#include "treelistctrl.h"

namespace creaImageIO
{

 
  //====================================================================
  class WxGimmickFieldsView : public wxPanel
  {
  public:
    WxGimmickFieldsView() { }
    WxGimmickFieldsView(wxWindow *parent, const wxWindowID id,
			    const wxPoint& pos, const wxSize& size,
			    long style);
    virtual ~WxGimmickFieldsView();

    void UpdateFields(DicomDatabase* db);
    void UpdateValues(DicomNode* node);
    void SetColors( const wxColour& DatabaseColour,
		    const wxColour& DatabaseBgColour,
		    const wxColour& PatientColour,
		    const wxColour& PatientBgColour,
		    const wxColour& StudyColour,
		    const wxColour& StudyBgColour,
		    const wxColour& SeriesColour,
		    const wxColour& SeriesBgColour,
		    const wxColour& ImageColour,
		    const wxColour& ImageBgColour);

  private:

    wxTreeListCtrl* mTreeListCtrl;
    wxTreeItemId mRootId;
    wxTreeItemId mItemId[5];


  };
  //====================================================================













  
} // namespace creaImageIO


#endif // #ifndef __creaImageIOWxGimmickFieldsView_h_INCLUDED__
